#Program  : PIAGE
#Version  : 1.0
#Date     : 04.03.2008
#Purpose  : Power and sample size estimation for indirect matched case-control association studies of gene-environment interaction
#Programmer: Rebecca Hein, Lars Beckmann
#Contact  : r.hein@dkfz-heidelberg.de
#Copyright (C) 2008 Deutsches Krebsforschungszentrum, DKFZ (German Cancer Research Center), Division of Cancer Epidemiology

#This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the
#Free Software Foundation; either version 2 of the License, or (at your option) any later version.
#This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation,
#Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
#A copy of the GNU Public License is attached to the program documentation.

LD<-function(fT,fM){
    
    if((1-fT-fM)<0){
        fTM_min<-abs(1-fT-fM)
    }else{
        fTM_min<-0
    }
    fTM_max<-min(fT,fM)
    
    d_min<-fTM_min-fT*fM
    d_max<-fTM_max-fT*fM
    
    if(d_min<0){
        r2_min<-0
    }else{
        r2_min<-d_min^2/(fT*(1-fT)*fM*(1-fM))
    }
    
    r2_max<-d_max^2/(fT*(1-fT)*fM*(1-fM))
    
    out<-cbind(d_min,d_max,r2_min,r2_max)
    
    return(out)
}
